//--------------------------------------------------------------
// File     : main.c
// Datum    : 14.04.2013
// Version  : 1.0
// Autor    : UB
// EMail    : mc-4u(@)t-online.de
// Web      : www.mikrocontroller-4u.de
// CPU      : STM32F4
// IDE      : CooCox CoIDE 1.7.0
// Module   : CMSIS_BOOT, M4_CMSIS_CORE
// Funktion : Demo der LCD-Library (SSD1289)
// Hinweis  : Diese zwei Files muessen auf 8MHz stehen
//              "cmsis_boot/stm32f4xx.h"
//              "cmsis_boot/system_stm32f4xx.c"
//--------------------------------------------------------------

#include <stdlib.h>
#include <string.h>
#include "main.h"
#include "stm32_ub_lcd_ssd1289.h"
#include "stm32_ub_ov9655.h"
#include "stm32_ub_uart.h"



int main(void)
{
  OV9655_ERR_t check;
  char buf[RX_BUF_SIZE]; // puffer fuer Datenempfang
  UART_RXSTATUS_t checkrx;
  uint32_t n;


  SystemInit(); // Quarz Einstellungen aktivieren

  // Init der UARTs
  // Com3 mit 921600 Baud
  UB_Uart_Init();

  // String per UART senden (mit LineFeed+CarriageReturn)
  //UB_Uart_SendString(COM3,"Hier ist UART3 [PC10,PC11]",LFCR);

  // init vom Camera-Modul (OV9655)
  // Init vom Display
  if((UB_LCD_Init()==SUCCESS)&&(UB_OV9655_Init()==OV9655_OK)) {

    // wenn alles OK -> Capture-Mode starten
    UB_LCD_FillScreen(RGB_COL_GREEN);
	UB_OV9655_CaptureStart();
  }
  else {
    // bei einem Fehler
	// Display mit einer Farbe loeschen
	UB_LCD_FillScreen(RGB_COL_RED);

	// Cursor setzen
	UB_LCD_SetCursor2Draw(0,0);
	// einen blauen Strich zeichnen
	for(n=0;n<321;n++) {
	LCD_RAM=RGB_COL_BLUE;
	}
  }

  char regs[3] = "00";
  char vals[3] = "00";
  int16_t int_wert;
  int reg, val;

  while(1)
  {
	  // check ob Daten an UART3 empfangen werden (string: "{0xaa,0xbb}", abschließen mit CR)
	  checkrx=UB_Uart_ReceiveString(COM3,buf);
	  if(checkrx==RX_READY) {

		  //UB_Uart_SendString(COM3,buf,LFCR);
		  // wenn Daten empfangen wurden

		  // extrahiere register und wert
		  strncpy(regs, buf+3, 2);
		  sscanf(regs, "%x", &reg);
		  strncpy(vals, buf+8, 2);
		  sscanf(vals, "%x", &val);

		  // setze neuen wert
		  UB_OV9655_CaptureStop();
		  int_wert=UB_I2C2_WriteByte(OV9655_I2C_ADR, reg, val);
		  UB_I2C2_Delay(OV9655_I2C_WR_PAUSE);
		  if(int_wert<0) {
			  UB_Uart_SendString(COM3,"error",LFCR);
		  }
		  else UB_Uart_SendString(COM3,"ok",LFCR);
		  UB_OV9655_CaptureStart();
	  }
  }
}

